local portTable = {
  {name = "Nexus Gate", loc = "nexus", target = "self", level = 17, class = 'wiz', connections={"nexus", "dreadlands", "greatdivide", "gfaydark", "netherbian", "northkarana", "poknowledge", "shadowhaven", "bazaar", "toxxulia"}},
  {name = "Nexus Portal", loc = "nexus", target = "group", level = 29, class = 'wiz', connections={"nexus", "dreadlands", "greatdivide", "gfaydark", "netherbian", "northkarana", "poknowledge", "shadowhaven", "bazaar", "toxxulia"}},
  {name = "North Gate", loc = "northkarana", target = "self", level = 18, class = 'wiz', connections={"northkarana", "eastkarana", "southkarana", "nexus", "qey2hh1"}},
  {name = "North Portal", loc = "northkarana", target = "group", level = 25, class = 'wiz', connections={"northkarana", "eastkarana", "southkarana", "nexus", "qey2hh1"}},
  {name = "Tox Gate", loc = "toxxulia", target = "self", level = 19, class = 'wiz', connections={"toxxulia", "barren", "poknowledge", "nexus", "paineel", "erudnext"}},
  {name = "Tox Portal", loc = "toxxulia", target = "group", level = 28, class = 'wiz', connections={"toxxulia", "barren", "poknowledge", "nexus", "paineel", "erudnext"}},
  {name = "Blightfire Moors Gate", loc = "moors", target = "self", level = 20, class = 'wiz', connections={"moors", "crescent", "mesa", "highpasshold", "poknowledge", "stonehive"}},
  {name = "Blightfire Moors Portal", loc = "moors", target = "group", level = 20, class = 'wiz', connections={"moors", "crescent", "mesa", "highpasshold", "poknowledge", "stonehive"}},
  {name = "Grimling Gate", loc = "grimling", target = "self", level = 20, class = 'wiz', connections={"grimling", "acrylia", "hollowshade", "tenebrous"}},
  {name = "Grimling Portal", loc = "grimling", target = "group", level = 29, class = 'wiz', connections={"grimling", "acrylia", "hollowshade", "tenebrous"}},
  {name = "Fay Gate", loc = "gfaydark", target = "self", level = 20, class = 'wiz', connections={"gfaydark", "butcher", "crushbone", "draniksscar", "lfaydark", "poknowledge", "nexus", "felwithea"}},
  {name = "Fay Portal", loc = "gfaydark", target = "group", level = 27, class = 'wiz', connections={"gfaydark", "butcher", "crushbone", "draniksscar", "lfaydark", "poknowledge", "nexus", "felwithea"}},
  {name = "Knowledge Gate", loc = "poknowledge", target = "self", level = 27, class = 'wiz', connections={"moors", "butcher", "draniksscar", "everfrost", "feerrott2", "fieldofbone", "firiona", "greatdivide", "gfaydark", "guildlobby", "gunthak", "innothule", "nektulos", "qeynos2", "potimea", "potranquility", "shadeweaver", "shadeweavertwo", "shadowrest", "steamfontmts", "arena", "bazaar", "feerrott", "nexus", "greatdividtwo", "overthere", "overtheretwo", "rathemtn", "toxxulia", "freeportwest", "poknowledge"}},
  {name = "Knowledge Portal", loc = "poknowledge", target = "group", level = 38, class = 'wiz', connections={"moors", "butcher", "draniksscar", "everfrost", "feerrott2", "fieldofbone", "firiona", "greatdivide", "gfaydark", "guildlobby", "gunthak", "innothule", "nektulos", "qeynos2", "potimea", "potranquility", "shadeweaver", "shadeweavertwo", "shadowrest", "steamfontmts", "arena", "bazaar", "feerrott", "nexus", "greatdividtwo", "overthere", "overtheretwo", "rathemtn", "toxxulia", "freeportwest", "poknowledge"}},
  {name = "Stonebrunt Gate", loc = "stonebrunt", target = "self", level = 21, class = 'wiz', connections={"stonebrunt", "gunthak", "warrens"}},
  {name = "Stonebrunt Portal", loc = "stonebrunt", target = "group", level = 27, class = 'wiz', connections={"stonebrunt", "gunthak", "warrens"}},
  {name = "Common Gate", loc = "commonlands", target = "self", level = 21, class = 'wiz', connections={"commonlands", "befallenb", "nektulos", "kithicor", "northro", "freeportwest"}},
  {name = "Common Portal", loc = "commonlands", target = "group", level = 35, class = 'wiz', connections={"commonlands", "befallenb", "nektulos", "kithicor", "northro", "freeportwest"}},
  {name = "Twilight Gate", loc = "twilight", target = "self", level = 22, class = 'wiz', connections={"twilight", "fungusgrove", "katta", "scarlet"}},
  {name = "Twilight Portal", loc = "twilight", target = "group", level = 33, class = 'wiz', connections={"twilight", "fungusgrove", "katta", "scarlet"}},
  {name = "Nek Gate", loc = "nektulos", target = "self", level = 22, class = 'wiz', connections={"nektulos", "commonlands", "corathus", "lavastorm", "neriaka", "neriakb", "neriakc", "neriakd", "poknowledge"}},
  {name = "Nek Portal", loc = "nektulos", target = "group", level =32 , class = 'wiz', connections={"nektulos", "commonlands", "corathus", "lavastorm", "neriaka", "neriakb", "neriakc", "neriakd", "poknowledge"}},
  {name = "Ro Gate", loc = "northro", target = "self", level = 22, class = 'wiz', connections={"northro", "commonlands", "freeporteast", "freeportsewers", "iceclad", "southro", "takishruins", "eastwastestwo"}},
  {name = "Ro Portal", loc = "northro", target = "group", level = 36, class = 'wiz', connections={"northro", "commonlands", "freeporteast", "freeportsewers", "iceclad", "southro", "takishruins", "eastwastestwo"}},
  {name = "Cazic Gate", loc = "cazicthule", target = "self", level = 23, class = 'wiz', connections={"cazicthule", "feerrott"}},
  {name = "Cazic Portal", loc = "cazicthule", target = "group", level = 33, class = 'wiz', connections={"cazicthule", "feerrott"}},
  {name = "West Gate", loc = "qey2hh1", target = "self", level = 23, class = 'wiz', connections={"qey2hh1", "ethernere", "northkarana", "qeytoqrg"}},
  {name = "West Portal", loc = "qey2hh1", target = "group", level = 37, class = 'wiz', connections={"qey2hh1", "ethernere", "northkarana", "qeytoqrg"}},
  {name = "Combine Gate", loc = "dreadlands", target = "self", level = 24, class = 'wiz', connections={"dreadlands", "burningwood", "firiona", "frontiermtns", "karnor", "nexus"}},
  {name = "Combine Portal", loc = "dreadlands", target = "group", level = 34, class = 'wiz', connections={"dreadlands", "burningwood", "firiona", "frontiermtns", "karnor", "nexus"}},
  {name = "Dawnshroud Gate", loc = "dawnshroud", target = "self", level = 29, class = 'wiz', connections={"dawnshroud", "griegsend", "maiden", "netherbian", "sseru"}},
  {name = "Dawnshroud Portal", loc = "dawnshroud", target = "group", level = 39, class = 'wiz', connections={"dawnshroud", "griegsend", "maiden", "netherbian", "sseru"}},
  {name = "Iceclad Gate", loc = "iceclad", target = "self", level = 32, class = 'wiz', connections={"iceclad", "eastwastes", "frozenshadow", "northro"}},
  {name = "Iceclad Portal", loc = "iceclad", target = "group", level = 33, class = 'wiz', connections={"iceclad", "eastwastes", "frozenshadow", "northro"}},
  {name = "Great Divide Gate", loc = "self", target = "self", level = 34, class = 'wiz', connections={"greatdivide", "eastwastes", "poknowledge", "thurgadinb", "nexus", "thurgadina", "velketor", "mischiefplane"}},
  {name = "Great Divide Portal", loc = "group", target = "group", level = 36, class = 'wiz', connections={"greatdivide", "eastwastes", "poknowledge", "thurgadinb", "nexus", "thurgadina", "velketor", "mischiefplane"}},
  {name = "Tishan's Relocation", loc = "skyfire", target = "group", level = 36, class = 'wiz', connections={"skyfire", "burningwood", "overthere", "veeshan"}},
  {name = "Markar's Relocation", loc = "emeraldjungle", target = "group", level = 37, class = 'wiz', connections={"emeraldjungle", "citymist", "dalnir", "fieldofbone", "trakanon"}},
  {name = "Wakening Lands Gate", loc = "wakening", target = "self", level = 38, class = 'wiz', connections={"wakening", "kael", "growthplane", "skyshrine"}},
  {name = "Wakening Lands Portal", loc = "wakening", target = "group", level = 42, class = 'wiz', connections={"wakening", "kael", "growthplane", "skyshrine"}},
  {name = "Evacuate Ro", loc = "southro", target = "group", level = 38, class = 'wiz', connections={"southro", "innothule", "northro", "takishruins", "timorous"}},
  {name = "Cobalt Scar Gate", loc = "cobaltscar", target = "self", level = 39, class = 'wiz', connections={"cobaltscar", "mischiefplane", "sirens", "skyshrine"}},
  {name = "Cobalt Scar Portal", loc = "cobaltscar", target = "group", level = 43, class = 'wiz', connections={"cobaltscar", "mischiefplane", "sirens", "skyshrine"}},
  {name = "Alter Plane: Hate", loc = "hateplaneb", target = "group", level = 46, class = 'wiz', connections={"hateplaneb"}},
  {name = "Alter Plane: Sky", loc = "airplane", target = "group", level = 46, class = 'wiz', connections={"airplane"}},
  {name = "Tranquility Gate", loc = "potranquility", target = "self", level = 51, class = 'wiz', connections={"potranquility", "pofire", "potactics", "poair", "honora", "podisease", "poinnovation", "pojustice", "poknowledge", "ponightmare", "postorms", "potimea", "potorment", "povalor", "powar", "powater", "codecay", "solrotower", "stratos", "bothunder", "poeartha"}},
  {name = "Tranquility Portal", loc = "potranquility", target = "group", level = 54, class = 'wiz', connections={"potranquility", "pofire", "potactics", "poair", "honora", "podisease", "poinnovation", "pojustice", "poknowledge", "ponightmare", "postorms", "potimea", "potorment", "povalor", "powar", "powater", "codecay", "solrotower", "stratos", "bothunder", "poeartha"}},
  {name = "Undershore Gate", loc = "eastkorlach", target = "self", level = 51, class = 'wiz', connections={"eastkorlach", "corathus", "illsalin", "westkorlach"}},
  {name = "Undershore  Portal", loc = "eastkorlach", target = "group", level = 51, class = 'wiz', connections={"eastkorlach", "corathus", "illsalin", "westkorlach"}},
  {name = "Arcstone Gate", loc = "arcstone", target = "self", level = 51, class = 'wiz', connections={"arcstone", "freeporteast", "relic", "freeportwest"}},
  {name = "Arcstone Portal", loc = "arcstone", target = "group", level = 51, class = 'wiz', connections={"arcstone", "freeporteast", "relic", "freeportwest"}},
  {name = "Natimbi Gate", loc = "natimbi", target = "self", level = 52, class = 'wiz', connections={"natimbi", "abysmal", "kodtaz", "nedaria", "qinimi", "qvic"}},
  {name = "Natimbi Portal", loc = "natimbi", target = "group", level = 54, class = 'wiz', connections={"natimbi", "abysmal", "kodtaz", "nedaria", "qinimi", "qvic"}},
  {name = "Barindu Gate", loc = "barindu", target = "self", level = 52, class = 'wiz', connections={"barindu", "ferubi", "qinimi", "riwwi", "tipt", "vxed"}},
  {name = "Barindu Portal", loc = "barindu", target = "group", level = 55, class = 'wiz', connections={"barindu", "ferubi", "qinimi", "riwwi", "tipt", "vxed"}},
  {name = "Bloodfields Gate", loc = "bloodfields", target = "self", level = 53, class = 'wiz', connections={"bloodfields", "draniksscar", "dranik"}},
  {name = "Bloodfields Portal", loc = "bloodfields", target = "group", level = 55, class = 'wiz', connections={"bloodfields", "draniksscar", "dranik"}},
  {name = "Sunderock Springs Gate", loc = "sunderock", target = "self", level = 60, class = 'wiz', connections={"sunderock", "direwind", "mesa", "vergalid"}},
  {name = "Sunderock Springs Portal", loc = "sunderock", target = "group", level = 60, class = 'wiz', connections={"sunderock", "direwind", "mesa", "vergalid"}},
  {name = "Slaughter Gate", loc = "wallofslaughter", target = "self", level = 60, class = 'wiz', connections={"wallofslaughter", "anguish", "chambersa", "causeway"}},
  {name = "Slaughter Portal", loc = "wallofslaughter", target = "group", level = 64, class = 'wiz', connections={"wallofslaughter", "anguish", "chambersa", "causeway"}},
  {name = "Katta Castrum Gate", loc = "kattacastrum", target = "self", level = 64, class = 'wiz', connections={"kattacastrum", "atiiki", "solteris", "thalassius", "buriedsea", "zhisza"}},
  {name = "Katta Castrum Portal", loc = "kattacastrum", target = "group", level = 69, class = 'wiz', connections={"kattacastrum", "atiiki", "solteris", "thalassius", "buriedsea", "zhisza"}},
  {name = "Icefall Glacier Gate", loc = "icefall", target = "self", level = 70, class = 'wiz', connections={"icefall", "steppes", "valdeholm"}},
  {name = "Icefall Glacier Portal", loc = "icefall", target = "group", level = 70, class = 'wiz', connections={"icefall", "steppes", "valdeholm"}},
  {name = "Dragonscale Hills Gate", loc = "dragonscale", target = "self", level = 75, class = 'wiz', connections={"dragonscale", "crystallos", "dragonscaleb", "mechanotus", "gnomemtn", "lopingplains", "guardian", "steamfont", "steamfactory", "dragonscalea"}},
  {name = "Dragonscale Hills Portal", loc = "dragonscale", target = "group", level = 75, class = 'wiz', connections={"dragonscale", "crystallos", "dragonscaleb", "mechanotus", "gnomemtn", "lopingplains", "guardian", "steamfont", "steamfactory", "dragonscalea"}},
  {name = "Plane of Time Gate", loc = "potimea", target = "self", level = 80, class = 'wiz', connections={"potimea", "poknowledge", "potimeb", "potranquility", "thevoida"}},
  {name = "Plane of Time Portal", loc = "potimea", target = "group", level = 80, class = 'wiz', connections={"potimea", "poknowledge", "potimeb", "potranquility", "thevoida"}},
  {name = "Brell's Rest Gate", loc = "brellsrest", target = "self", level = 80, class = 'wiz', connections={"brellsrest", "brellsarena", "brellstemple", "coolingchamber", "shiningcity", "pellucid", "underquarry", "hole"}},
  {name = "Brell's Rest Portal", loc = "brellsrest", target = "group", level = 80, class = 'wiz', connections={"brellsrest", "brellsarena", "brellstemple", "coolingchamber", "shiningcity", "pellucid", "underquarry", "hole"}},
  {name = "Grounds Gate", loc = "housegarden", target = "self", level = 85, class = 'wiz', connections={"housegarden", "thulehouse1", "well"}},
  {name = "Grounds Portal", loc = "housegarden", target = "group", level = 85, class = 'wiz', connections={"housegarden", "thulehouse1", "well"}},
  {name = "Sarith Gate", loc = "sarithcity", target = "self", level = 90, class = 'wiz', connections={"sarithcity", "beastdomain", "cityofbronze", "resplendent", "rubak", "arelis"}},
  {name = "Sarith Portal", loc = "sarithcity", target = "group", level = 90, class = 'wiz', connections={"sarithcity", "beastdomain", "cityofbronze", "resplendent", "rubak", "arelis"}},
  {name = "Alra Gate", loc = "pillarsofalra", target = "self", level = 92, class = 'wiz', connections={"pillarsofalra", "resplendent", "windsong"}},
  {name = "Alra Portal", loc = "pillarsofalra", target = "group", level = 92, class = 'wiz', connections={"pillarsofalra", "resplendent", "windsong"}},
  {name = "Shard's Landing Gate", loc = "shardslanding", target = "self", level = 95, class = 'wiz', connections={"shardslanding", "breedinggrounds", "chapterhouse", "chelsithreborn", "eastwastesshard", "cityofbronze", "eviltree", "grelleth", "poshadow", "sepulcher", "xorbb"}},
  {name = "Shard's Landing Portal", loc = "shardslanding", target = "group", level = 95, class = 'wiz', connections={"shardslanding", "breedinggrounds", "chapterhouse", "chelsithreborn", "eastwastesshard", "cityofbronze", "eviltree", "grelleth", "poshadow", "sepulcher", "xorbb"}},
  {name = "West Karana Gate", loc = "ethernere", target = "self", level = 95, class = 'wiz', connections={"ethernere", "arginhiz", "bixiewarfront", "deadhills", "neriakd", "thevoidh", "towerofrot", "qey2hh1"}},
  {name = "West Karana Portal", loc = "ethernere", target = "group", level = 95, class = 'wiz', connections={"ethernere", "arginhiz", "bixiewarfront", "deadhills", "neriakd", "thevoidh", "towerofrot", "qey2hh1"}},
  {name = "Lceanium Gate", loc = "lceanium", target = "self", level = 98, class = 'wiz', connections={"lceanium", "nexus", "scorchedwoods"}},
  {name = "Lceanium Portal", loc = "lceanium", target = "group", level = 99, class = 'wiz', connections={"lceanium", "nexus", "scorchedwoods"}},
  {name = "Tempest Temple Gate", loc = "tempesttemple", target = "self", level = 100, class = 'wiz', connections={"tempesttemple", "brotherisland", "endlesscaverns", "kattacastrumb", "buriedsea"}},
  {name = "Tempest Temple Portal", loc = "tempesttemple", target = "group", level = 100, class = 'wiz', connections={"tempesttemple", "brotherisland", "endlesscaverns", "kattacastrumb", "buriedsea"}},
  {name = "Skyfire Gate", loc = "skyfiretwo", target = "self", level = 100, class = 'wiz', connections={"skyfiretwo", "gorowyn", "scorchedwoods", "overtheretwo", "veeshantwo"}},
  {name = "Skyfire Portal", loc = "skyfiretwo", target = "group", level = 100, class = 'wiz', connections={"skyfiretwo", "gorowyn", "scorchedwoods", "overtheretwo", "veeshantwo"}},
  {name = "Esianti Gate", loc = "esianti", target = "", level = 108, class = 'wiz', connections={"esianti", "mearatas", "stratos"}},
  {name = "Esianti Portal", loc = "esianti", target = "", level = 109, class = 'wiz', connections={"esianti", "mearatas", "stratos"}},
  {name = "The Great Divide Gate", loc = "greatdividetwo", target = "self", level = 113, class = 'wiz', connections={"greatdividetwo", "poknowledge", "eastwastestwo", "velketortwo"}},
  {name = "The Great Divide Portal", loc = "greatdividetwo", target = "group", level = 114, class = 'wiz', connections={"greatdividetwo", "poknowledge", "eastwastestwo", "velketortwo"}},
  {name = "Cobalt Scar Gate", loc = "cobaltscartwo", target = "self", level = 113, class = 'wiz', connections={"cobaltscartwo", "skyshrinetwo", "kaektwo", "westwastestwo"}},
  {name = "Cobalt Scar Portal", loc = "cobaltscartwo", target = "group", level = 114, class = 'wiz', connections={"cobaltscartwo", "skyshrinetwo", "kaektwo", "westwastestwo"}},
  {name = "Shadeweaver's Tangle Gate", loc = "shadeweavertwo", target = "self", level = 114, class = 'wiz', connections={"shadeweavertwo", "firefallpass", "paludaltwo"}},
  {name = "Shadeweaver's Tangle Portal", loc = "shadeweavertwo", target = "group", level = 115, class = 'wiz', connections={"shadeweavertwo", "firefallpass", "paludaltwo"}},
  {name = "Shadow Valley Gate", loc = "shadowvalley", target = "self", level = 115, class = 'wiz', connections={"shadowvalley", "basilica", "akhevatwo"}},
  {name = "Shadow Valley Portal", loc = "shadowvalley", target = "group", level = 116, class = 'wiz', connections={"shadowvalley", "basilica", "akhevatwo"}},
  {name = "Laurionn Gate", loc = "laurioninn", target="self", level = 120, class = 'wiz', connections={"laurioninn", "ankexfen", "moorsofnokk", "pallomen", "potranquility", "herosforge", "timorousfalls", "unkemptwoods"}},
  {name = "Laurionn Portal", loc = "laurioninn", target="self", level = 121, class = 'wiz', connections={"laurioninn", "ankexfen", "moorsofnokk", "pallomen", "potranquility", "herosforge", "timorousfalls", "unkemptwoods"}},
  {name = "Ring of Surefall Glade", loc = "qrg", target = "self", level = 15, class = "dru", connections = {"qrg", "jaggedpine", "qeytoqrg"}},
  {name = "Circle of Surefall Glade", loc = "qrg", target = "group", level = 26, class = "dru", connections = {"qrg", "jaggedpine", "qeytoqrg"}},
  {name = "Ring of Karana", loc = "northkarana", target = "self", level = 15, class = "dru", connections = {"northkarana", "eastkarana", "southkarana", "nexus", "qey2hh1"}},
  {name = "Circle of Karana", loc = "northkarana", target = "group", level = 25, class = "dru", connections = {"northkarana", "eastkarana", "southkarana", "nexus", "qey2hh1"}},
  {name = "Ring of Butcher", loc = "butcher", target = "self", level = 16, class = "dru", connections = {"butcher", "cauldron", "gfaydark", "oceanoftears", "poknowledge", "kaladima", "timorous"}},
  {name = "Circle of Butcher", loc = "butcher", target = "group", level = 25, class = "dru", connections = {"butcher", "cauldron", "gfaydark", "oceanoftears", "poknowledge", "kaladima", "timorous"}},
  {name = "Ring of Commons", loc = "commonlands", target = "self", level = 17, class = "dru", connections = {"commonlands", "befallenb", "nektulos", "kithicor", "northro", "freeportwest"}},
  {name = "Circle of Commons", loc = "commonlands", target = "group", level = 27, class = "dru", connections = {"commonlands", "befallenb", "nektulos", "kithicor", "northro", "freeportwest"}},
  {name = "Ring of Toxxulia", loc = "toxxulia", target = "self", level = 17, class = "dru", connections = {"toxxulia", "barren", "poknowledge", "nexus", "paineel", "erudnext"}},
  {name = "Circle of Toxxulia", loc = "toxxulia", target = "group", level = 25, class = "dru", connections = {"toxxulia", "barren", "poknowledge", "nexus", "paineel", "erudnext"}},
  {name = "Ring of Grimling", loc = "grimling", target = "self", level = 18, class = "dru", connections = {"grimling", "acrylia", "hollowshade", "tenebrous"}},
  {name = "Circle of Grimling", loc = "grimling", target = "group", level = 29, class = "dru", connections = {"grimling", "acrylia", "hollowshade", "tenebrous"}},
  {name = "Ring of the Nexus", loc = "nexus", target = "self", level = 19, class = "dru", connections = {"nexus", "dreadlands", "greatdivide", "gfaydark", "netherbian", "northkarana", "poknowledge", "shadowhaven", "bazaar", "toxxulia"}},
  {name = "Circle of the Nexus", loc = "nexus", target = "group", level = 26, class = "dru", connections = {"nexus", "dreadlands", "greatdivide", "gfaydark", "netherbian", "northkarana", "poknowledge", "shadowhaven", "bazaar", "toxxulia"}},
  {name = "Ring of Stonebrunt", loc = "stonebrunt", target = "self", level = 20, class = "dru", connections = {"stonebrunt", "gunthak", "warrens"}},
  {name = "Circle of Stonebrunt", loc = "stonebrunt", target = "group", level = 28, class = "dru", connections = {"stonebrunt", "gunthak", "warrens"}},
  {name = "Ring of Ro", loc = "southro", target = "self", level = 20, class = "dru", connections = {"southro", "innothule", "northro", "takishruins", "timorous"}},
  {name = "Circle of Ro", loc = "southro", target = "group", level = 32, class = "dru", connections = {"southro", "innothule", "northro", "takishruins", "timorous"}},
  {name = "Ring of Blightfire Moors", loc = "moors", target = "self", level = 20, class = "dru", connections = {"moors", "crescent", "mesa", "highpasshold", "poknowledge", "stonehive"}},
  {name = "Circle of Blightfire Moors", loc = "moors", target = "group", level = 20, class = "dru", connections = {"moors", "crescent", "mesa", "highpasshold", "poknowledge", "stonehive"}},
  {name = "Ring of Steamfont", loc = "steamfontmts", target = "self", level = 21, class = "dru", connections = {"steamfontmts", "akanon", "argath", "dragonscale", "lfaydark", "lopingplains", "poknowledge"}},
  {name = "Circle of Steamfont", loc = "steamfontmts", target = "group", level = 31, class = "dru", connections = {"steamfontmts", "akanon", "argath", "dragonscale", "lfaydark", "lopingplains", "poknowledge"}},
  {name = "Ring of Lavastorm", loc = "lavastorm", target = "self", level = 22, class = "dru", connections = {"lavastorm", "delvea", "soldungb", "najena", "nektulos", "soltemple", "soldunga", "broodlands"}},
  {name = "Circle of Lavastorm", loc = "lavastorm", target = "group", level = 30, class = "dru", connections = {"lavastorm", "delvea", "soldungb", "najena", "nektulos", "soltemple", "soldunga", "broodlands"}},
  {name = "Ring of Feerrott", loc = "feerrott", target = "self", level = 22, class = "dru", connections = {"feerrott", "cazicthule", "feerrott2", "innothule", "oggok", "fearplane", "poknowledge", "rathemtn"}},
  {name = "Circle of Feerrott", loc = "feerrott", target = "group", level = 32, class = "dru", connections = {"feerrott", "cazicthule", "feerrott2", "innothule", "oggok", "fearplane", "poknowledge", "rathemtn"}},
  {name = "Ring of Twilight", loc = "twilight", target = "self", level = 23, class = "dru", connections = {"twilight", "fungusgrove", "katta", "scarlet"}},
  {name = "Circle of Twilight", loc = "twilight", target = "group", level = 33, class = "dru", connections = {"twilight", "fungusgrove", "katta", "scarlet"}},
  {name = "Ring of the Combines", loc = "dreadlands", target = "self", level = 24, class = "dru", connections = {"dreadlands", "burningwood", "firiona", "frontiermtns", "karnor", "nexus"}},
  {name = "Circle of the Combines", loc = "dreadlands", target = "group", level = 33, class = "dru", connections = {"dreadlands", "burningwood", "firiona", "frontiermtns", "karnor", "nexus"}},
  {name = "Ring of Knowledge", loc = "poknowledge", target = "self", level = 25, class = "dru", connections = {"poknowledge", "moors", "butcher", "draniksscar", "everfrost", "feerrott2", "fieldofbone", "firiona", "greatdivide", "gfaydark", "guildlobby", "gunthak", "innothule", "nektulos", "qeynos2", "potimea", "potranquility", "shadeweaver", "shadeweavertwo", "shadowrest", "steamfontmts", "arena", "bazaar", "feerrott", "nexus", "greatdividtwo", "overthere", "overtheretwo", "rathemtn", "toxxulia", "freeportwest"}},
  {name = "Circle of Knowledge", loc = "poknowledge", target = "group", level = 38, class = "dru", connections = {"poknowledge", "moors", "butcher", "draniksscar", "everfrost", "feerrott2", "fieldofbone", "firiona", "greatdivide", "gfaydark", "guildlobby", "gunthak", "innothule", "nektulos", "qeynos2", "potimea", "potranquility", "shadeweaver", "shadeweavertwo", "shadowrest", "steamfontmts", "arena", "bazaar", "feerrott", "nexus", "greatdividtwo", "overthere", "overtheretwo", "rathemtn", "toxxulia", "freeportwest"}},
  {name = "Ring of Misty", loc = "mistythicket", target = "self", level = 25, class = "dru", connections = {"mistythicket", "runnyeye", "poknowledge", "rivervale"}},
  {name = "Circle of Misty", loc = "mistythicket", target = "group", level = 36, class = "dru", connections = {"mistythicket", "runnyeye", "poknowledge", "rivervale"}},
  {name = "Succor East", loc = "eastkarana", target = "group", level = 26, class = "dru", connections = {"eastkarana", "beholder", "highpasshold", "northkarana"}},
  {name = "Ring of Dawnshroud", loc = "dawnshroud", target = "self", level = 29, class = "dru", connections = {"dawnshroud", "griegsend", "maiden", "netherbian", "sseru"}},
  {name = "Circle of Dawnshroud", loc = "dawnshroud", target = "group", level = 37, class = "dru", connections = {"dawnshroud", "griegsend", "maiden", "netherbian", "sseru"}},
  {name = "Ring of Iceclad", loc = "iceclad", target = "self", level = 31, class = "dru", connections = {"iceclad", "eastwastes", "frozenshadow", "northro"}},
  {name = "Circle of Iceclad", loc = "iceclad", target = "group", level = 32, class = "dru", connections = {"iceclad", "eastwastes", "frozenshadow", "northro"}},
  {name = "Ring of Great Divide", loc = "greatdivide", target = "self", level = 33, class = "dru", connections = {"greatdivide", "eastwastes", "poknowledge", "thurgadinb", "nexus", "thurgadina", "velketor", "mischiefplane"}},
  {name = "Circle of Great Divide", loc = "greatdivide", target = "group", level = 38, class = "dru", connections = {"greatdivide", "eastwastes", "poknowledge", "thurgadinb", "nexus", "thurgadina", "velketor", "mischiefplane"}},
  {name = "Ring of Wakening Lands", loc = "wakening", target = "self", level = 36, class = "dru", connections = {"wakening", "kael", "growthplane", "skyshrine"}},
  {name = "Circle of Wakening Lands", loc = "wakening", target = "group", level = 40, class = "dru", connections = {"wakening", "kael", "growthplane", "skyshrine"}},
  {name = "Wind of the South", loc = "emeraldjungle", target = "group", level = 37, class = "dru", connections = {"emeraldjungle", "citymist", "dalnir", "fieldofbone", "trakanon"}},
  {name = "Wind of the North", loc = "skyfire", target = "group", level = 39, class = "dru", connections = {"skyfire", "burningwood", "overthere", "veeshan"}},
  {name = "Ring of Cobalt Scar", loc = "cobaltscar", target = "self", level = 39, class = "dru", connections = {"cobaltscar", "mischiefplane", "sirens", "skyshrine"}},
  {name = "Circle of Cobalt Scar", loc = "cobaltscar", target = "group", level = 42, class = "dru", connections = {"cobaltscar", "mischiefplane", "sirens", "skyshrine"}},
  {name = "Ring of Tranquility", loc = "potranquility", target = "self", level = 51, class = "dru", connections = {"potranquility", "pofire", "potactics", "poair", "honora", "podisease", "poinnovation", "pojustice", "poknowledge", "ponightmare", "postorms", "potimea", "potorment", "povalor", "powar", "powater", "codecay", "solrotower", "stratos", "bothunder", "poeartha"}},
  {name = "Circle of Tranquility", loc = "potranquility", target = "group", level = 54, class = "dru", connections = {"potranquility", "pofire", "potactics", "poair", "honora", "podisease", "poinnovation", "pojustice", "poknowledge", "ponightmare", "postorms", "potimea", "potorment", "povalor", "powar", "powater", "codecay", "solrotower", "stratos", "bothunder", "poeartha"}},
  {name = "Ring of Undershore", loc = "eastkorlach", target = "self", level = 52, class = "dru", connections = {"eastkorlach", "corathus", "illsalin", "westkorlach"}},
  {name = "Circle of Undershore", loc = "eastkorlach", target = "group", level = 52, class = "dru", connections = {"eastkorlach", "corathus", "illsalin", "westkorlach"}},
  {name = "Ring of Arcstone", loc = "arcstone", target = "self", level = 52, class = "dru", connections = {"arcstone", "freeporteast", "relic", "freeportwest"}},
  {name = "Circle of Arcstone", loc = "arcstone", target = "group", level = 52, class = "dru", connections = {"arcstone", "freeporteast", "relic", "freeportwest"}},
  {name = "Ring of Bloodfields", loc = "bloodfields", target = "self", level = 53, class = "dru", connections = {"bloodfields", "draniksscar", "dranik"}},
  {name = "Circle of Bloodfields", loc = "bloodfields", target = "group", level = 55, class = "dru", connections = {"bloodfields", "draniksscar", "dranik"}},
  {name = "Ring of Buried Sea", loc = "buriedsea", target = "self", level = 54, class = "dru", connections = {"buriedsea", "barren", "katacastrum", "tempesttemple"}},
  {name = "Circle of Buried Sea", loc = "buriedsea", target = "group", level = 59, class = "dru", connections = {"buriedsea", "barren", "katacastrum", "tempesttemple"}},
  {name = "Ring of Natimbi", loc = "natimbi", target = "self", level = 52, class = "dru", connections = {"natimbi", "abysmal", "kodtaz", "nedaria", "qinimi", "qvic"}},
  {name = "Circle of Natimbi", loc = "natimbi", target = "group", level = 54, class = "dru", connections = {"natimbi", "abysmal", "kodtaz", "nedaria", "qinimi", "qvic"}},
  {name = "Ring of Barindu", loc = "barindu", target = "self", level = 52, class = "dru", connections = {"barindu", "ferubi", "qinimi", "riwwi", "tipt", "vxed"}},
  {name = "Circle of Barindu", loc = "barindu", target = "group", level = 55, class = "dru", connections = {"barindu", "ferubi", "qinimi", "riwwi", "tipt", "vxed"}},
  {name = "Ring of The Steppes", loc = "steppes", target = "self", level = 60, class = "dru", connections = {"steppes", "mesa", "icefall"}},
  {name = "Circle of The Steppes", loc = "steppes", target = "group", level = 60, class = "dru", connections = {"steppes", "mesa", "icefall"}},
  {name = "Ring of Slaughter", loc = "wallofslaughter", target = "self", level = 62, class = "dru", connections = {"wallofslaughter", "anguish", "chambersa", "causeway"}},
  {name = "Circle of Slaughter", loc = "wallofslaughter", target = "group", level = 64, class = "dru", connections = {"wallofslaughter", "anguish", "chambersa", "causeway"}},
  {name = "Ring of Direwind", loc = "direwind", target = "self", level = 70, class = "dru", connections = {"direwind", "ashengate", "sunderock"}},
  {name = "Circle of Direwind", loc = "direwind", target = "group", level = 70, class = "dru", connections = {"direwind", "ashengate", "sunderock"}},
  {name = "Ring of Loping Plains", loc = "lopingplains", target = "self", level = 75, class = "dru", connections = {"lopingplains", "bloodmoon", "dragonscale", "hillsofshade", "steamfont"}},
  {name = "Circle of Loping Plains", loc = "lopingplains", target = "group", level = 75, class = "dru", connections = {"lopingplains", "bloodmoon", "dragonscale", "hillsofshade", "steamfont"}},
  {name = "Ring of Plane of Time", loc = "potimea", target = "self", level = 80, class = "dru", connections = {"potimea", "poknowledge", "potimeb", "potranquility", "thevoida"}},
  {name = "Circle of Plane of Time", loc = "potimea", target = "group", level = 80, class = "dru", connections = {"potimea", "poknowledge", "potimeb", "potranquility", "thevoida"}},
  {name = "Ring of Brell's Rest", loc = "brellsrest", target = "self", level = 80, class = "dru", connections = {"brellsrest", "brellsarena", "brellstemple", "coolingchamber", "shiningcity", "pellucid", "underquarry", "hole"}},
  {name = "Circle of Brell's Rest", loc = "brellsrest", target = "group", level = 80, class = "dru", connections = {"brellsrest", "brellsarena", "brellstemple", "coolingchamber", "shiningcity", "pellucid", "underquarry", "hole"}},
  {name = "Ring of the Grounds", loc = "housegarden", target = "self", level = 85, class = "dru", connections = {"housegarden", "thulehouse1", "well"}},
  {name = "Circle of the Grounds", loc = "housegarden", target = "group", level = 85, class = "dru", connections = {"housegarden", "thulehouse1", "well"}},
  {name = "Ring of the Domain", loc = "beastdomain", target = "self", level = 90, class = "dru", connections = {"beastdomain", "argath", "eviltree", "sarithcity"}},
  {name = "Circle of the Domain", loc = "beastdomain", target = "group", level = 90, class = "dru", connections = {"beastdomain", "argath", "eviltree", "sarithcity"}},
  {name = "Ring of Alra", loc = "pillarsalra", target = "self", level = 92, class = "dru", connections = {"pillarsalra", "resplendent", "windsong"}},
  {name = "Circle of Alra", loc = "pillarsalra", target = "group", level = 92, class = "dru", connections = {"pillarsalra", "resplendent", "windsong"}},
  {name = "Ring of the Landing", loc = "shardslanding", target = "self", level = 95, class = "dru", connections = {"shardslanding", "breedinggrounds", "chapterhouse", "chelsithreborn", "eastwastesshard", "cityofbronze", "eviltree", "grelleth", "poshadow", "sepulcher", "xorbb"}},
  {name = "Circle of the Landing", loc = "shardslanding", target = "group", level = 95, class = "dru", connections = {"shardslanding", "breedinggrounds", "chapterhouse", "chelsithreborn", "eastwastesshard", "cityofbronze", "eviltree", "grelleth", "poshadow", "sepulcher", "xorbb"}},
  {name = "Ring of West Karana", loc = "ethernere", target = "self", level = 95, class = "dru", connections = {"ethernere", "arginhiz", "bixiewarfront", "deadhills", "neriakd", "thevoidh", "towerofrot", "qey2hh1"}},
  {name = "Circle of West Karana", loc = "ethernere", target = "group", level = 95, class = "dru", connections = {"ethernere", "arginhiz", "bixiewarfront", "deadhills", "neriakd", "thevoidh", "towerofrot", "qey2hh1"}},
  {name = "Ring of Lceanium", loc = "lceanium", target = "self", level = 98, class = "dru", connections = {"lceanium", "nexus", "scorchedwoods"}},
  {name = "Circle of Lceanium", loc = "lceanium", target = "group", level = 99, class = "dru", connections = {"lceanium", "nexus", "scorchedwoods"}},
  {name = "Ring of the Tempest", loc = "tempesttemple", target = "self", level = 100, class = "dru", connections = {"tempesttemple", "brotherisland", "endlesscaverns", "kattacastrumb", "buriedsea"}},
  {name = "Circle of the Tempest", loc = "tempesttemple", target = "group", level = 100, class = "dru", connections = {"tempesttemple", "brotherisland", "endlesscaverns", "kattacastrumb", "buriedsea"}},
  {name = "Ring of Skyfire", loc = "skyfiretwo", target = "self", level = 100, class = "dru", connections = {"skyfiretwo", "gorowyn", "scorchedwoods", "overtheretwo", "veeshantwo"}},
  {name = "Circle of Skyfire", loc = "skyfiretwo", target = "group", level = 100, class = "dru", connections = {"skyfiretwo", "gorowyn", "scorchedwoods", "overtheretwo", "veeshantwo"}},
  {name = "Ring of Esianti", loc = "esianti", target = "self", level = 108, class = "dru", connections = {"esianti", "mearatas", "stratos"}},
  {name = "Circle of Esianti", loc = "esianti", target = "group", level = 109, class = "dru", connections = {"esianti", "mearatas", "stratos"}},
  {name = "Ring of The Great Divide", loc = "greatdividetwo", target = "self", level = 113, class = "dru", connections = {"greatdividetwo", "poknowledge", "eastwastestwo", "velketortwo"}},
  {name = "Circle of The Great Divide", loc = "greatdividetwo", target = "group", level = 114, class = "dru", connections = {"greatdividetwo", "poknowledge", "eastwastestwo", "velketortwo"}},
  {name = "Ring of Cobalt Scar", loc = "cobaltscartwo", target = "self", level = 113, class = "dru", connections = {"cobaltscartwo", "skyshrinetwo", "kaektwo", "westwastestwo"}},
  {name = "Circle of Cobalt Scar", loc = "cobaltscartwo", target = "group", level = 114, class = "dru", connections = {"cobaltscartwo", "skyshrinetwo", "kaektwo", "westwastestwo"}},
  {name = "Ring of Shadeweaver's Tangle", loc = "shadeweavertwo", target = "self", level = 114, class = "dru", connections = {"shadeweavertwo", "firefallpass", "paludaltwo"}},
  {name = "Circle of Shadeweaver's Tangle", loc = "shadeweavertwo", target = "group", level = 115, class = "dru", connections = {"shadeweavertwo", "firefallpass", "paludaltwo"}},
  {name = "Ring of Shadow Valley", loc = "shadowvalley", target = "self", level = 115, class = "dru", connections = {"shadowvalley", "basilica", "akhevatwo"}},
  {name = "Circle of Shadow Valley", loc = "shadowvalley", target = "group", level = 116, class = "dru", connections = {"shadowvalley", "basilica", "akhevatwo"}},
  {name = "Ring of Laurionn", loc = "laurioninn", target="self", level = 120, class = 'dru', connections={"laurioninn", "ankexfen", "moorsofnokk", "pallomen", "potranquility", "herosforge", "timorousfalls", "unkemptwoods"}},
  {name = "Circle of Laurionn", loc = "laurioninn", target="self", level = 121, class = 'dru', connections={"laurioninn", "ankexfen", "moorsofnokk", "pallomen", "potranquility", "herosforge", "timorousfalls", "unkemptwoods"}}
}

return portTable